/**
******************************************************************************
* @file    pcm1770.c
* @author  wk
* @version
* @date
*/

/* Includes ------------------------------------------------------------------*/
#include "at32f403a_407.h"
#include "usart.h"
#include "ff.h"
#include "play.h"
#include "string.h"
#include <stdlib.h>
#include "wm8988_i2s.h"
#include "diskio.h"
#include "mp3common.h"
#include "at32_audio_conf.h"
#include "wm8988.h"
#include "at32f403a_407_board.h"

// MP3

MP3FrameInfo mp3FrameInfo;      // Content is the output from MP3GetLastFrameInfo,
// we only read this once, and conclude it will be the same in all frames
// Maybe this needs to be changed, for different requirements.
HMP3Decoder hMP3Decoder;        // Content is the pointers to all buffers and information for the MP3 Library
int bytesLeft;                  // Saves how many bytes left in readbuf
volatile u32 outOfData;         // Used to set when out of data to quit playback

u8 readBuf[READBUF_SIZE];       // Read buffer where data from SD card is read to
u8 *readPtr;                    // Pointer to the next new data
s32 offset;                      // Used to save the offset to the next frame
int errs = 0;                    // Return value from MP3decoder


extern short * /*volatile*/ P_AudioBuff;//DMA͵ָ
extern vu16 curr_buff_done;  //һݲɵı־
//uint16_t Out_Data_Offset;

//FATFS fs;
FIL F;
volatile static FRESULT fres = FR_OK;

#define FILE_NAME_LEN 40//ļȣ⵽ļ40 ļ 
#define MAX_FILE_NUM  120//ֵ֧ļ

//volatile static vu32 Play_index, FileNum;
////volatile char Count;

vu8 g_mode = 1;
vu8 g_press = 0;
vu8 g_next;
vu8 g_pervious;
vu8 g_pause;//һ һ ͣ ־

typedef struct buffs
{
  short BufData[OUTPUT_BUFFER_SIZE];	//Ϊ4608
  struct buffs * Next;
} BuffDef;

BuffDef Buff[2];//out buff
BuffDef* BuffP = &Buff[0];

int MpegAudioDecoder(FIL *InputFp)
{
  static UINT br, frame_count, vol = 32;
  /* Initilizes the MP3 Library */
  hMP3Decoder = MP3InitDecoder();
  Buff[0].Next = &Buff[1];
  Buff[1].Next = &Buff[0];

  /* Reset counters */
  bytesLeft = 0;
  outOfData = 0;
  readPtr = readBuf;
  curr_buff_done = 2;
  frame_count = 0;
//      BuffP->Next = &Buff[1];
  fres = f_read(InputFp, readBuf, READBUF_SIZE, &br);
  bytesLeft += br;

  if( (fres != FR_OK) || (br == 0))
  {
    return 1;
  }

  while(1)
  {
    if(g_press)
    {
      switch (g_mode)
      {
        case 1://ͣ|
          delay_ms(300);
          g_press = 0;
          while(!g_press);
          delay_ms(300);
          g_press=0;
          printf("pause/play\r\n");
        break;
        case 2:     
          if(vol<64)
          {
            WM8988_SetDACSpk_Volume(++vol);
          }
          g_press=0;
          printf("volume%d\r\n", vol*100/64);
        break;
        case 3:
          if(vol>0)
          {
            WM8988_SetDACSpk_Volume(--vol);
          }
          g_press=0;
          printf("volume%d\r\n", vol*100/64);
        break;
        case 4:
          g_pervious = 1;
          g_press=0;
          printf("previous\r\n");
        break;
        case 5:
          g_next = 1;
          g_press=0;
          printf("next\r\n");
        break;
        default:
        break;
      }
    }
    
    if (g_pervious | g_next)
    {
      break;//
    }

    /* find start of next MP3 frame - assume EOF if no sync found */
    offset = MP3FindSyncWord(readPtr, bytesLeft);

    if (offset < 0)
    {
      //outOfData = 1;
      break;
    }
    else
    {
      readPtr += offset;                         //data start point
      bytesLeft -= offset;                 //in buffer
      errs = MP3Decode(hMP3Decoder, &readPtr, &bytesLeft, (BuffP->BufData), 0);

      if (errs)
      {
        //˴Ҫټ err жϴ
        printf("an err occer %d \r\n", errs);

//        if (++err_count>=60)  //࣬ ļĽ
//        break;
//        if (errs == ERR_MP3_INVALID_FRAMEHEADER)
//        {
//          break;
//        }
      }

      if (bytesLeft < READBUF_SIZE)
      {
        memmove(readBuf, readPtr, bytesLeft);
        fres = f_read(InputFp, readBuf + bytesLeft, READBUF_SIZE - bytesLeft, &br);

        if( (fres != FR_OK) || (br == 0))
        {
          break;
        }

        if (br < READBUF_SIZE - bytesLeft)
        {
          memset(readBuf + bytesLeft + br, 0, READBUF_SIZE - bytesLeft - br);
        }

        bytesLeft = READBUF_SIZE;
        readPtr = readBuf;
      }

//					TestLEDToggle();
      MP3GetLastFrameInfo(hMP3Decoder, &mp3FrameInfo);

      if (frame_count == 0)
      {
        printf("%lu bp/s audio MPEG layer %d, %d Hz sample rate, %d Chanel.\r\n",
               mp3FrameInfo.bitrate, mp3FrameInfo.layer, mp3FrameInfo.samprate, mp3FrameInfo.nChans);


        if  ((mp3FrameInfo.layer < 3) || (mp3FrameInfo.bitrate <= 0) || (mp3FrameInfo.samprate <= 0)) //((mp3FrameInfo.bitrate>=320000) ʵ inputbufСҪ
        {
          //helixֻ֧ MP3 	 vbrļ õһЩĪ
          printf("bitrate or layer not support!\r\n");
          break;
        }
      }

      frame_count++;

      //sample_rate(mp3FrameInfo.samprate);
      if(1 == mp3FrameInfo.nChans)
      {
        Convert_Mono((BuffP->BufData));
      }
      else
      {
        Convert_Stereo((BuffP->BufData));
      }

      while (curr_buff_done == 0 )
      {
        ;
      }

      if (curr_buff_done != 0)
      {
//        Out_Data_Offset = 1;
        curr_buff_done = 0;
        P_AudioBuff = BuffP->BufData;
        WM8988_Set_Freq(mp3FrameInfo.samprate);
      }

      BuffP = BuffP->Next;
    }
  }
  
  printf("frame_count = %d\r\n", frame_count);
  MP3FreeDecoder(hMP3Decoder);

  return 0;
}

